"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pipeMaybeReactFromMemberExpression = exports.isImportDeclaration = exports.getImportNamesPace = exports.getImportDeclaration = exports.getImportDefault = exports.getImport = exports.getCallExpression = void 0;
const tslib_1 = require("tslib");
const t = tslib_1.__importStar(require("@babel/types"));
const E = tslib_1.__importStar(require("effect/Effect"));
const O = tslib_1.__importStar(require("effect/Option"));
const getCallExpression = (x) => {
    return x.pipe(E.map(O.map((a) => (t.isCallExpression(a.init) ? O.some(a.init) : O.none()))));
};
exports.getCallExpression = getCallExpression;
const getImport = (x) => {
    return E.sync(() => (x.path.isImportSpecifier() ? O.some(x.path.node) : O.none()));
};
exports.getImport = getImport;
const getImportDefault = (x) => {
    return E.sync(() => (x.path.isImportDefaultSpecifier() ? O.some(x.path.node) : O.none()));
};
exports.getImportDefault = getImportDefault;
const getImportDeclaration = (x) => {
    return E.sync(() => (x.path.isImportDeclaration() ? O.some(x.path.node) : O.none()));
};
exports.getImportDeclaration = getImportDeclaration;
const getImportNamesPace = (x) => {
    return E.sync(() => (x.path.isImportNamespaceSpecifier() ? O.some(x.path.node) : O.none()));
};
exports.getImportNamesPace = getImportNamesPace;
const isImportDeclaration = (x) => {
    return E.sync(() => t.isImportDeclaration(x.node));
};
exports.isImportDeclaration = isImportDeclaration;
/**
 * @step `Step #1`
 * @param {t.MemberExpression} node
 * @returns
 */
const getCreateElementIdent = (node) => {
    return O.Do.pipe(() => t.isIdentifier(node.property, { name: 'createElement' }) ? O.some(node.object) : O.none());
};
/**
 * @step `Step #2`
 */
const getReactIdent = (node) => {
    return node.pipe(O.flatMap((x) => t.isIdentifier(x, { name: 'react' }) || t.isIdentifier(x, { name: 'React' })
        ? O.some(x)
        : O.none()));
};
/**
 * @step `Step #3`
 */
const getBinding = (path) => (node) => {
    return node.pipe(O.flatMap((a) => O.fromNullable(path.scope.getBinding(a.name))));
};
/**
 * @step `Step #3`
 */
const bindingToVariableDeclarator = (binding) => {
    return binding.pipe(O.flatMap((x) => (x.path.isVariableDeclarator() ? O.some(x.path.node) : O.none())));
};
const getBindingCallExpression = (binding) => {
    return binding.pipe(bindingToVariableDeclarator, O.flatMap((x) => (t.isCallExpression(x.init) ? O.some(x.init) : O.none())));
};
/**
 * @step `Step #4`
 */
const getReactRequire = (node) => {
    return node.pipe(O.flatMap((x) => t.isIdentifier(x.callee, { name: 'require' }) &&
        t.isStringLiteral(x.arguments[0], { value: 'react' })
        ? O.some(true)
        : O.none()));
};
const pipeMaybeReactFromMemberExpression = (path) => {
    return E.Do.pipe(() => O.some(path), () => getCreateElementIdent(path.node), getReactIdent, getBinding(path), getBindingCallExpression, getReactRequire, O.getOrElse(() => false));
};
exports.pipeMaybeReactFromMemberExpression = pipeMaybeReactFromMemberExpression;
//# sourceMappingURL=import.effects.js.map