"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMemberExpressionProgram = void 0;
const tslib_1 = require("tslib");
const E = tslib_1.__importStar(require("effect/Effect"));
const Exit = tslib_1.__importStar(require("effect/Exit"));
const O = tslib_1.__importStar(require("effect/Option"));
const services_1 = require("./services");
const createMemberExpressionProgram = (path) => {
    const context = (0, services_1.createElementRunnable)(path);
    const program = E.all([services_1.CreateElementSvc, services_1.NodeBindingSvc, services_1.CallExpressionSvc]).pipe(E.flatMap(([createElement, binding, callExp]) => {
        const fromRequire = (x) => x.pipe(binding.getVariableDeclarator, binding.getCallExpression, (node) => [callExp.getReactRequire(node), callExp.isInteropRequire(node)], O.firstSomeOf);
        return createElement
            .getCreateElementExpression()
            .pipe(createElement.getReactIdent, binding.getBinding)
            .pipe((x) => [fromRequire(x), binding.getImportDeclaration(x)], O.firstSomeOf);
    }));
    return E.provide(program, context).pipe(E.runSyncExit, Exit.match({
        onFailure() {
            return false;
        },
        onSuccess() {
            return true;
        },
    }));
};
exports.createMemberExpressionProgram = createMemberExpressionProgram;
//# sourceMappingURL=programs.js.map