import { Binding, NodePath } from '@babel/traverse';
import * as t from '@babel/types';
import * as Ctx from 'effect/Context';
import * as O from 'effect/Option';
declare const CreateElementSvc_base: Ctx.TagClass<CreateElementSvc, "CreateElementSvc", {
    readonly path: NodePath<t.MemberExpression>;
    readonly getCreateElementExpression: () => O.Option<t.MemberExpression>;
    readonly getReactIdent: (node: O.Option<t.MemberExpression>) => O.Option<t.Identifier>;
}>;
export declare class CreateElementSvc extends CreateElementSvc_base {
}
declare const NodeBindingSvc_base: Ctx.TagClass<NodeBindingSvc, "NodeBindingSvc", {
    readonly getBinding: (node: O.Option<t.Identifier>) => O.Option<Binding>;
    readonly getVariableDeclarator: (binding: O.Option<Binding>) => O.Option<t.VariableDeclarator>;
    readonly getCallExpression: (node: O.Option<t.VariableDeclarator>) => O.Option<readonly [t.VariableDeclarator, t.CallExpression]>;
    readonly getImportDeclaration: (binding: O.Option<Binding>) => O.Option<boolean>;
}>;
export declare class NodeBindingSvc extends NodeBindingSvc_base {
}
declare const CallExpressionSvc_base: Ctx.TagClass<CallExpressionSvc, "CallExpressionSvc", {
    readonly getReactRequire: (node: O.Option<readonly [t.VariableDeclarator, t.CallExpression]>) => O.Option<boolean>;
    readonly isInteropRequire: (node: O.Option<readonly [t.VariableDeclarator, t.CallExpression]>) => O.Option<boolean>;
}>;
export declare class CallExpressionSvc extends CallExpressionSvc_base {
}
export declare const createElementRunnable: (path: NodePath<t.MemberExpression>) => Ctx.Context<CreateElementSvc | NodeBindingSvc | CallExpressionSvc>;
export {};
