"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createElementRunnable = exports.CallExpressionSvc = exports.NodeBindingSvc = exports.CreateElementSvc = void 0;
const tslib_1 = require("tslib");
const t = tslib_1.__importStar(require("@babel/types"));
const Ctx = tslib_1.__importStar(require("effect/Context"));
const O = tslib_1.__importStar(require("effect/Option"));
class CreateElementSvc extends Ctx.Tag('CreateElementSvc')() {
}
exports.CreateElementSvc = CreateElementSvc;
class NodeBindingSvc extends Ctx.Tag('NodeBindingSvc')() {
}
exports.NodeBindingSvc = NodeBindingSvc;
class CallExpressionSvc extends Ctx.Tag('CallExpressionSvc')() {
}
exports.CallExpressionSvc = CallExpressionSvc;
const createElementRunnable = (path) => {
    return Ctx.empty().pipe(Ctx.add(CreateElementSvc, {
        path,
        getCreateElementExpression() {
            if (t.isIdentifier(this.path.node.property, { name: 'createElement' })) {
                return O.some(this.path.node);
            }
            return O.none();
        },
        getReactIdent(node) {
            return node.pipe(O.flatMap((x) => {
                if (t.isIdentifier(x.object, { name: 'react' }) ||
                    t.isIdentifier(x.object, { name: 'React' })) {
                    return O.some(x.object);
                }
                if (t.isMemberExpression(x.object) &&
                    t.isIdentifier(x.object.object, { name: '_react' }) &&
                    t.isIdentifier(x.object.property, { name: 'default' })) {
                    return O.some(x.object.object);
                }
                return O.none();
            }));
        },
    }), Ctx.add(NodeBindingSvc, {
        getBinding(node) {
            return node.pipe(O.flatMap((a) => O.fromNullable(path.scope.getBinding(a.name))));
        },
        getVariableDeclarator(binding) {
            return binding.pipe(O.flatMap((x) => (x.path.isVariableDeclarator() ? O.some(x.path.node) : O.none())));
        },
        getCallExpression(node) {
            return node.pipe(O.flatMap((x) => t.isCallExpression(x.init) ? O.some([x, x.init]) : O.none()));
        },
        getImportDeclaration(binding) {
            return binding.pipe(O.flatMap((x) => x.path.parentPath &&
                t.isImportDeclaration(x.path.parentPath.node) &&
                x.path.parentPath.node.source.value.toLowerCase() === 'react'
                ? O.some(true)
                : O.none()));
        },
    }), Ctx.add(CallExpressionSvc, {
        getReactRequire(node) {
            return node.pipe(O.flatMap(([, node]) => t.isIdentifier(node.callee, { name: 'require' }) &&
                t.isStringLiteral(node.arguments[0], { value: 'react' })
                ? O.some(true)
                : O.none()));
        },
        isInteropRequire(node) {
            return node.pipe(O.flatMap(([, node]) => {
                if (t.isIdentifier(node.callee, { name: '_interopRequireDefault' }) && // const <name> = _interopRequireDefault(require("react"))
                    t.isCallExpression(node.arguments[0]) &&
                    t.isIdentifier(node.arguments[0].callee, { name: 'require' }) &&
                    t.isStringLiteral(node.arguments[0].arguments[0], {
                        value: 'react',
                    })) {
                    return O.some(true);
                }
                return O.none();
            }));
        },
    }));
};
exports.createElementRunnable = createElementRunnable;
//# sourceMappingURL=services.js.map