"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createVisitorContext = void 0;
const allowedFileRegex = /^(?!.*[/\\](react|react-native|react-native-web|@native-twin\/*)[/\\]).*$/;
const isValidFile = (x = '') => allowedFileRegex.test(x);
const createVisitorStateContext = (state) => {
    return {
        isValidPath: isValidFile(state.filename),
    };
};
// const isReactCreateElementIdent = <T>(path: NodePath<T>) =>
//   path.isIdentifier({ name: 'createElement' });
// const createScopeContext = (binding?: Binding) => {
//   const path = binding?.path;
//   if (!path) return null;
//   return {
//     isVariableDeclaration: path.isVariableDeclaration,
//   };
// };
const createVisitorContext = () => (path, state) => {
    const stateContext = createVisitorStateContext(state);
    return {
        stateContext,
        tree: {
            root: path,
            parent: path.parent,
        },
    };
};
exports.createVisitorContext = createVisitorContext;
//# sourceMappingURL=visitor-context.js.map