"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const helper_module_imports_1 = require("@babel/helper-module-imports");
const plugin_constants_1 = require("./constants/plugin.constants");
const path_effects_1 = require("./effects/path.effects");
const programs_1 = require("./effects/programs");
const visitor_context_1 = require("./effects/visitor-context");
function nativeTwinBabelPlugin() {
    // const t = babel.types;
    const createContext = (0, visitor_context_1.createVisitorContext)();
    return {
        name: '@native-twin/babel',
        visitor: {
            MemberExpression(path, state) {
                const context = createContext(path, state);
                if (!context.stateContext.isValidPath)
                    return;
                const shouldReplace = (0, programs_1.createMemberExpressionProgram)(path);
                if (shouldReplace) {
                    path.replaceWith((0, helper_module_imports_1.addNamed)(path, ...plugin_constants_1.PLUGIN_IMPORT_META));
                    return;
                }
            },
            Identifier(path, state) {
                const context = createContext(path, state);
                if (!context.stateContext.isValidPath)
                    return;
                if (path.node.name === 'createElement' && path.parentPath.isCallExpression()) {
                    const binding = path.scope.getBinding(path.node.name);
                    if (!binding)
                        return;
                    if ((0, path_effects_1.isReactRequire)(binding) || (0, path_effects_1.isReactImport)(binding)) {
                        path.replaceWith((0, helper_module_imports_1.addNamed)(path, ...plugin_constants_1.PLUGIN_IMPORT_META));
                    }
                }
            },
        },
    };
}
exports.default = nativeTwinBabelPlugin;
//# sourceMappingURL=index.js.map